package slimeknights.tconstruct.smeltery.block;

import net.minecraft.block.Block;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.IStringSerializable;
import net.minecraft.world.World;

import slimeknights.mantle.block.EnumBlock;
import slimeknights.tconstruct.library.TinkerRegistry;
import slimeknights.tconstruct.smeltery.tileentity.TileSmelteryComponent;

public class BlockEnumSmeltery<T extends Enum<T> & EnumBlock.IEnumMeta & IStringSerializable> extends EnumBlock<T> implements ITileEntityProvider {

  public BlockEnumSmeltery(PropertyEnum<T> prop, Class<T> clazz) {
    this(Material.field_151576_e, prop, clazz);
  }

  public BlockEnumSmeltery(Material material, PropertyEnum<T> prop, Class<T> clazz) {
    super(material, prop, clazz);

    func_149711_c(3F);
    func_149752_b(20F);
    func_149672_a(field_149777_j);
    this.func_149647_a(TinkerRegistry.tabSmeltery);
    this.field_149758_A = true; // has TE
  }

  @Override
  public TileEntity func_149915_a(World worldIn, int meta) {
    return new TileSmelteryComponent();
  }

  /* BlockContainer TE handling */
  @Override
  public void func_180663_b(World worldIn, BlockPos pos, IBlockState state) {
    TileEntity te = worldIn.func_175625_s(pos);
    if(te instanceof TileSmelteryComponent) {
      ((TileSmelteryComponent) te).notifyMasterOfChange();
    }

    super.func_180663_b(worldIn, pos, state);
    worldIn.func_175713_t(pos);
  }

  @Override
  public void func_176204_a(World worldIn, BlockPos pos, IBlockState state, Block neighborBlock) {
    TileEntity te = worldIn.func_175625_s(pos);
    if(te instanceof TileSmelteryComponent) {
      ((TileSmelteryComponent) te).notifyMasterOfChange();
    }
  }

  @Override
  public boolean func_180648_a(World worldIn, BlockPos pos, IBlockState state, int eventID, int eventParam) {
    super.func_180648_a(worldIn, pos, state, eventID, eventParam);
    TileEntity tileentity = worldIn.func_175625_s(pos);
    return tileentity != null && tileentity.func_145842_c(eventID, eventParam);
  }
}
